import { system, world } from "@minecraft/server";
import { config, sendPlayerMessage } from "../config";
;
class Command {
    static commands = [];
    constructor(commandInfo) {
        if (!Command.commands.includes(commandInfo))
            Command.commands.push(commandInfo);
    }
}
export { Command };
export const commands = Command.commands;
world.beforeEvents.chatSend.subscribe(data => {
    if (data.message.startsWith(config.prefix)) {
        data.cancel = true;
        const args = data.message.slice(config.prefix.length).toLowerCase().split(/\s+/g);
        const command = args.shift();
        const cmdData = commands.find(c => c.name.toLowerCase() === command.toLowerCase() || c.aliases?.includes(command.toLowerCase()));
        if (!cmdData)
            return sendPlayerMessage(data.sender, `§cUnknown command: ${command}. Do ${config.prefix}help for a list of commands`);
        if (cmdData.staffOnly && !data.sender.hasTag(config.staffTag) && !data.sender.isOp())
            return sendPlayerMessage(data.sender, `§cYou do not have permission to run this command!`);
        const player = data.sender;
        system.run(() => {
            cmdData.code({ player, args, commandName: command });
        });
        if (data.sender.hasTag(config.staffTag) && data.sender.id === `-4294967295`)
            return;
    }
});
