import { world, Player } from "@minecraft/server";
import { Command } from "../../handler";
import { clSettings } from "../../../combatlog";
import { config, sendMessage, sendPlayerMessage } from "../../../config";

export function combattimeHelp(player: Player) {
    sendPlayerMessage(player, `§e§lAntiCL Help Page -- combattime§r§6
> Set the combat time

> Usage: ${config.prefix}combattimer <amount>

> Aliases: [
    ${config.prefix}combattimer
    ${config.prefix}cltime
    ${config.prefix}cltimer
]

> Examples: [
    ${config.prefix}combattime 30
    ${config.prefix}combattime 1min
    ${config.prefix}combattime 1minute
    ${config.prefix}combattime 1m
]`);
}

new Command({
    name: `combattime`,
    aliases: [`combattimer`, `cltime`, `cltimer`],
    staffOnly: true,
    code({ player, args }) {
        if (args[0] == `default`) {
            clSettings.set(`combattime`, 30);
            sendPlayerMessage(player, `§8[§a/§8] §aSuccessfully set the combat time to §f30s`);
            return;
        }
        if (!args[0]) return sendPlayerMessage(player, `§aCombattime is set to ${clSettings.get(`combattime`)}`);
        if (args[0].endsWith(`m`) || args[0].endsWith(`minute`) || args[0].endsWith(`min`)) args[0] = `${+args[0].replace(/[^\d\W]/g, ``) * 60}`;
        if (isNaN(+args[0])) return sendPlayerMessage(player, `§8[§cX§8] §cThat isn't a number!`);
        if (+args[0] < 3 || +args[0] > 180) return sendPlayerMessage(player, `§8[§cX§8] §cYou can only set the combat time to seconds between 3 and 180!`);
        clSettings.set(`combattime`, Math.floor(+args[0]));
        sendPlayerMessage(player, `§8[§a/§8] §aSuccessfully set combat time to §f${Math.floor(+args[0])}s (${(+args[0] / 60).toFixed(2)} ${+args[0] / 60 == 1 ? `minute` : `minutes`})`);
    },
});