import { world, Player } from "@minecraft/server";
import { Command } from "../../handler";
import { clSettings } from "../../../combatlog";
import { config, sendMessage, sendPlayerMessage } from "../../../config";

export function sptimeHelp(player: Player) {
    sendPlayerMessage(player, `§e§lAntiCL Help Page -- spawnkilltime§r§6
> Set the spawn kill protection time (Amount of time before players can damage killed players again)

> Usage: ${config.prefix}spawnkilltime <amount/disable>

> Aliases: [
    ${config.prefix}sptime
]

> Examples: [
    ${config.prefix}spawnkilltime 30
    ${config.prefix}spawnkilltime 1minute
    ${config.prefix}sptime 1min
    ${config.prefix}sptime 1m
    ${config.prefix}sptime disable
]`);
}

new Command({
    name: `spawnkilltime`,
    aliases: [`sptime`],
    code({ player, args }) {
        if (args[0] == `default`) {
            clSettings.set(`spawnkilltime`, 30);
            args[0] = `30`;
            sendPlayerMessage(player, `§8[§a/§8] §aSuccessfully set spawnkill time to §f${+args[0]}s (${(+args[0] / 60).toFixed(2)} ${+args[0] / 60 == 1 ? `minute` : `minutes`})`);
            return;
        }
        if (args[0] == `disable`) {
            clSettings.set(`spawnkilltime`, 0);
            sendPlayerMessage(player, `§8[§a/§8] §aSuccessfully disabled spawnkill protection`);
            return;
        }
        if (!args[0]) return sendPlayerMessage(player, `§aSpawnkilltime is set to ${clSettings.get(`spawnkilltime`)}`);
        if (args[0].endsWith(`m`) || args[0].endsWith(`minute`) || args[0].endsWith(`min`)) args[0] = `${+args[0].replace(/[^\d\W]/g, ``) * 60}`;
        if (isNaN(+args[0])) return sendPlayerMessage(player, `§8[§cX§8] §cThat isn't a number!`);
        clSettings.set(`spawnkilltime`, Math.floor(+args[0]));
        if (+args[0] < 3 || +args[0] > 600) return sendPlayerMessage(player, `§8[§cX§8] §cYou can only set the spawnkill time to seconds between 3 and 600!`);
        sendPlayerMessage(player, `§8[§a/§8] §aSuccessfully set spawnkill time to §f${Math.floor(+args[0])}s (${(+args[0] / 60).toFixed(2)} ${+args[0] / 60 == 1 ? `minute` : `minutes`})`);
    }
});